package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.ConexionConfDAO;
import com.rjconsultores.ventaboletos.entidad.ConexionConf;
import com.rjconsultores.ventaboletos.entidad.ConexionCtrl;

@Repository("conexionConfDAO")
public class ConexionConfHibernateDAO extends GenericHibernateDAO<ConexionConf, Long>
		implements ConexionConfDAO {

	@Autowired
	public ConexionConfHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<ConexionConf> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}

	@Override
	public ConexionConf buscar(Long conexionCtrlId, Integer numgrupo) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("grupo", numgrupo));

		Criteria ctrl = c.createCriteria("conexionCtrl");
		ctrl.add(Restrictions.eq("conexionctrlId", conexionCtrlId));
		
		return (ConexionConf) c.uniqueResult();
	}

	@Override
	public List<ConexionConf> buscarPorConexionCtrl(ConexionCtrl conexionCtrl) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("conexionCtrl", conexionCtrl));

		return c.list();
	}
}
